/*
Copyright (C) 2014 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
function Calendar2(year, month, date) {
  this.setShukujitsu()
  this.dayS = "пڶ"
  if(Calendar2.arguments.length == 0)
    this.d = new Date()
  else
    this.d = new Date(year, month, date)
  this._set()
}

Calendar2.prototype.setShukujitsu = function() {
  this.shukujitsuList = life2Dt.trGetShukujitsu()
}

Calendar2.prototype.isShukujitsu = function() {
  var a = this.dataStr().substr(0, 8)
  if(this.shukujitsuList.indexOf(a) >= 0)
    return true
  return false
}

Calendar2.prototype._set = function() {
  this.year = this.d.getFullYear()
  this.month = this.d.getMonth() +1
  this.date = this.d.getDate()
  this.day = this.d.getDay() // 0:-6:
  this.hour = this.d.getHours()
  this.minute = this.d.getMinutes()
}

Calendar2.prototype._getLast = function(month) {
  switch(month){
  case 1: case 3: case 5: case 7: case 8: case 10: case 12: return 31
  case 2: return 28
  }
  return 30
}

Calendar2.prototype.dayStr = function() {
  return this.dayS.substr(this.day, 1)
}

Calendar2.prototype.set = function(year, month, date, hour, minute, second) {
  this.d = new Date(year, month -1, date, hour, minute, second)
  this._set()
}

Calendar2.prototype.get = function() {
  return [this.year, this.month, this.date, this.hour, this.minute, 0]
}

Calendar2.prototype.now = function() {
  this.d = new Date()
  this._set()
}

Calendar2.prototype.dataStr = function() {
  var s = "" + this.year
  if(this.month < 10) s += "0"
  s += this.month
  if(this.date < 10) s += "0"
  s += this.date
  if(this.hour < 10) s += "0"
  s += this.hour
  if(this.minute < 10) s += "0"
  s += this.minute
  return s
}

Calendar2.prototype.addDate = function(n) {
  this.d.setTime(this.d.getTime() + n *24*60*60*1000)
  this._set()
}

Calendar2.prototype.addMonth = function(n) {
  var ay = n /12
  ay = (ay > 0) ? Math.floor(ay) : Math.ceil(ay)
  var am = n %12
  var m = this.month + am
  if(m > 12){
    ay++
    m %= 12
  }
  if(m <= 0){
    ay--
    m += 12
  }
  var ld = this._getLast(m)
  if(this.date > ld) this.date = ld  
  this.set(this.year + ay, m, this.date, this.hour, this.minute, 0)
}

Calendar2.prototype.monthLast = function() {
  this.addMonth(1)
  this.set(this.year, this.month, 1, this.hour, this.minute, 0)
  this.addDate(-1)
}

Calendar2.prototype.nowStr = function() {
  this.now()
  return this.dataStr()
}

Calendar2.prototype.todayStr = function() {
  this.now()
  this.hour = 0
  this.minute = 0
  return this.dataStr()
}

Calendar2.prototype.dateTimeStr1 = function(dt) {
  this.set(parseInt(dt.substr(0, 4)), parseInt(dt.substr(4, 2)), parseInt(dt.substr(6, 2)),
           parseInt(dt.substr(8, 2)), parseInt(dt.substr(10, 2)), 0)
  var s = "" + this.hour + "" + this.minute + "ʬ " + this.date + "(" + this.dayStr() + ") "
  s += this.month + " " + this.year
  return s
}

Calendar2.prototype.dateStr1 = function(dt) {
  this.set(parseInt(dt.substr(0, 4)), parseInt(dt.substr(4, 2)), parseInt(dt.substr(6, 2)), 0, 0, 0)
  var s = "" + this.date + "(" + this.dayStr() + ") " + this.month + " " + this.year
  return s
}

Calendar2.prototype.dateStr2 = function(dt) {
  this.set(parseInt(dt.substr(0, 4)), parseInt(dt.substr(4, 2)), parseInt(dt.substr(6, 2)), 0, 0, 0)
  var s = "<span style=\"color: #"
  switch(this.day){
  case 0: s += "ff0000"; break
  case 3: s += "00aa00"; break
  case 6: s += "0000ff"; break
  }
  if(this.shukujitsuList.indexOf(dt) >= 0) s += "ff0000"
  s += ";\">" + this.date + "(" + this.dayStr() + ")</span>"
  s += "<span style=\"background-color: #eaeaea;\"> " + this.month + " / " + this.year + "</span>"
  return s
}
