/*
Copyright (C) 2014 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
function Data() {
  this.data = [] // [ "yyyymmddthhmm"(DataAndType), val, transactionKey ] t=typelife2.jsѿ
  this.getResult = []
  this.getKeyword = null // DataAndType or searchKey
  this.getType = -1
  this.addr = [] // "ɤ\n̾\n(Ԥͭ)"
}

Data.prototype.checkUpdate = function() {
  return (this.getKeyword == null) ? true : false
}

Data.prototype.set = function(dat, val, transactionKey) {
  this.data.push([dat, val, transactionKey])
  this.getKeyword = null
}

Data.prototype.del = function(transactionKey) {
  var i
  for(i = 0; i < this.data.length; i++){
    if(this.data[i][2] == transactionKey){
      this.data.splice(i, 1)
      break
    }
  }
  this.getKeyword = null
}

Data.prototype.get = function(keyword, type) {
  if(this.getKeyword == keyword && this.getType == type)
    return this.getResult
  this.getType = type
  this.getKeyword = keyword
  var a = this.data.sort(), i
  this.getResult = []
  switch(type){
  case life2DataGetTypeDate: //  Ⱦ13ο(dat)
    for(i = 0; i < a.length; i++){
      if(keyword < a[i][0])
        this.getResult.push(a[i])
    }
    break
  case life2DataGetTypeOr: {
    var b = keyword.split("\n"), j
    for(i = 0; i < a.length; i++){
      if(keyword == ""){
        this.getResult.push(a[i])
      }else{
        for(j = 0; j < b.length; j++){
          if(a[i][0].indexOf(b[j]) >= 0 || a[i][1].indexOf(b[j]) >= 0){
            this.getResult.push(a[i])
            break
          }
        }
      }
    }
  } break
  case life2DataGetTypeAnd: {
    var b = keyword.split("\n"), j
    for(i = 0; i < a.length; i++){
      if(keyword == ""){
        this.getResult.push(a[i])
      }else{
        var cnt = 0
        for(j = 0; j < b.length; j++){
          if(a[i][0].indexOf(b[j]) >= 0 || a[i][1].indexOf(b[j]) >= 0)
            cnt++
        }
        if(cnt == b.length)
          this.getResult.push(a[i])
      }
    }
  } break
  case life2DataGetTypeOneDay: { //  Ⱦ13ο(dat)
    var b = "" + life2TypeSch, c = keyword.substr(0, 8)
    for(i = 0; i < a.length; i++){
      var d = a[i][0].substr(0, 8)
      if(c < d) break
      if(a[i][0].substr(8, 1) != b) continue
      if(c == d) this.getResult.push(a[i])
    }
  } break
  }
  return this.getResult
}

Data.prototype.getFromTrKey = function(trKey) {
  var a = this.data, i
  for(i = 0; i < a.length; i++)
    if(a[i][2] == trKey)
      return a[i]
  return null
}

Data.prototype.removeAll = function() {
  this.data = [] // [ "yyyymmddthhmm"(DataAndType), val, transactionKey ] t=typelife2.jsѿ
  this.getResult = []
  this.getKeyword = null // DataAndType or searchKey
}

Data.prototype.getMemo2 = function() {
  var a = this.data.sort(), b = "" + life2TypeMemo, i
  var ret = []
  for(i = a.length -1; i >= 0; i--){
    if(a[i][0].substr(8, 1) == b)
      ret.push(a[i])
  }
  return ret
}

Data.prototype.initAddr2 = function(type, sep, del) {
  this.addr = []
  var a = "" + type, b = this.data.sort(function(a,b){if(a[2] > b[2]){return 1}else if(a[2] == b[2]){return 0}
                                                      else{return -1}}), tmp = ""
  for(var i = 0; i < b.length; i++){
    if(b[i][0].substr(8, 1) != a) continue
    var c = b[i][1].split(sep)
    for(var j = 0; j < c.length; j++){
      var d = c[j]
      if(tmp.indexOf(d) >= 0) continue
      if(d.indexOf(del) == 0){
        this.initAddr2Del(d.substr(del.length))
        continue
      }
      var e = d.substr(0, d.indexOf("\n", d.indexOf("\n") +1) +1)
      if(tmp.indexOf(e) >= 0)
        this.initAddr2Del(e)
      this.addr.push(d)
      tmp += d + " "
    }
  }
}

Data.prototype.initAddr2Del = function(d) {
  var a = this.addr
  for(var i = 0; i < a.length; i++){
    if(a[i].indexOf(d) == 0){
      a.splice(i, 1)
      return
    }
  }
  alert("Data.initAddr2Del: 顼")
}

Data.prototype.getAddr2 = function() {
  return this.addr.sort()
}
