/*
Copyright (C) 2014 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
function UiHidukeSet(v) { life2UiHiduke._set(v) }
function UiHidukeF() { life2UiHiduke._numBack() }
function UiHidukeToday() { life2UiHiduke.view("", null) }
function UiHidukeAddDate(n) { life2Cal.addDate(n); var a = life2UiHiduke; a._getCal(); a._view() }
function UiHidukeAddMonth(n) { life2Cal.addMonth(n); var a = life2UiHiduke; a._getCal(); a._view() }
function UiHidukeMonthFirst() { var a = life2UiHiduke; a.date = 1; a._setCal(); a._view() }
function UiHidukeMonthLast() { life2Cal.monthLast(); var a = life2UiHiduke; a._getCal(); a._view() }
function UiHidukeTime(n) {
  var a = life2UiHiduke
  switch(n){
  case 0: a.minute = 30; break
  case 1: a.hour = 6; a.minute = 0; break
  case 2: a.hour = 9; a.minute = 0; break
  case 3: a.hour = 12; a.minute = 0; break
  case 4: a.hour = 15; a.minute = 0; break
  case 5: a.hour = 18; a.minute = 0; break
  case 6: a.hour--; if(a.hour < 0) a.hour = 23; break
  case 7: a.hour++; if(a.hour > 23) a.hour = 0; break
  case 8: a.hour = 0; a.minute = 0; break
  }
  a._setCal(); a._view() 
}

UiHiduke.prototype._view = function() {
  var s = "<pre>"
  s += "<button onClick=\"UiHidukeSet(1)\"></button>"
  s += "       <button class=\"ui\" onClick=\"UiHidukeTime(1)\">6</button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeTime(2)\">9</button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeTime(3)\">12</button>\n"
  s += "<button class=\"ui\" onClick=\"UiHidukeSet(2)\">" + this.date + "</button>"
  s += " (" + life2Cal.dayStr() + ")"
  s += "      <button class=\"ui\" onClick=\"UiHidukeTime(4)\">15</button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeTime(5)\">18</button>\n"
  s += "<button class=\"ui\" onClick=\"UiHidukeSet(3)\">" + this.hour + "</button> : "
  s += "<button class=\"ui\" onClick=\"UiHidukeSet(4)\">" + this.minute + "</button>"
  s += "   <button class=\"ui\" onClick=\"UiHidukeTime(6)\"></button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeTime(7)\"></button>\n"
  s += "<button class=\"ui\" onClick=\"UiHidukeSet(5)\">" + this.month + "</button> / "
  s += "<button class=\"ui\" onClick=\"UiHidukeSet(6)\">" + this.year + "</button>"
  s += "    <button class=\"ui\" onClick=\"UiHidukeTime(0)\">30ʬ</button>\n"
  s += "<button class=\"ui\" onClick=\"UiHidukeToday()\"></button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeAddDate(-1)\"></button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeAddDate(1)\"></button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeAddDate(-7)\"></button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeAddDate(7)\">⽵</button>\n"
  s += "<button class=\"ui\" onClick=\"UiHidukeMonthFirst()\"></button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeMonthLast()\"></button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeAddMonth(-1)\"></button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeAddMonth(1)\"></button>\n"
  s += "<button class=\"ui\" onClick=\"UiHidukeAddMonth(-12)\">ǯ</button>"
  s += "<button class=\"ui\" onClick=\"UiHidukeAddMonth(12)\">ǯ</button>\n"
  s += "</pre>"
  this.obj.innerHTML = s
}

function UiHiduke(_obj) {
  this.obj = _obj
  this.year = 0
  this.month = 0
  this.date = 0
  this.hour = 0
  this.minute = 0
  this.func = null
  this.numBackParam = 0
}

UiHiduke.prototype.view = function(val, func) {
  if(val.match(/^\d+$/) == null) val = life2Cal.nowStr()
  this.year = parseInt(val.substr(0, 4))
  this.month = parseInt(val.substr(4, 2))
  this.date = parseInt(val.substr(6, 2))
  this.hour = parseInt(val.substr(8, 2))
  this.minute = parseInt(val.substr(10, 2))
  if(func != null) this.func = func
  this._setCal()
  this._view()
}

UiHiduke.prototype._getCal = function() {
  var a = life2Cal.get()
  this.year = a[0]
  this.month = a[1]
  this.date = a[2]
  this.hour = a[3]
  this.minute = a[4]
}

UiHiduke.prototype._setCal = function() {
  life2Cal.set(this.year, this.month, this.date, this.hour, this.minute, 0)
}

UiHiduke.prototype.get = function() {
  this._setCal()
  var s = life2Cal.dataStr() 
  return s
}
  
UiHiduke.prototype._set = function(v) {
  this.numBackParam = v
  switch(this.numBackParam){
  case 1: this.func(); return
  case 2: life2UiNum.view("" + this.date, UiHidukeF); return
  case 3: life2UiNum.view("" + this.hour, UiHidukeF); return
  case 4: life2UiNum.view("" + this.minute, UiHidukeF); return
  case 5: life2UiNum.view("" + this.month, UiHidukeF); return
  case 6: life2UiNum.view("" + this.year, UiHidukeF); return
  }
}

UiHiduke.prototype._numBack = function() {
  var s = life2UiNum.get()
  var n = parseInt(s)
  if(s == "") n = 0
  switch(this.numBackParam){
  case 2: this.date = n; break
  case 3: this.hour = n; break
  case 4: this.minute = n; break
  case 5: this.month = n; break
  case 6: this.year = n; break
  }
  this._setCal()
  this._view()
}
