/*
Copyright (C) 2014 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
life2Id = null
life2Dt = null
life2Cal = null
life2UiNum = null
life2UiHiduke = null
life2TypeSch = 1
life2TypeMemo = 2
life2TypeBook = 3
life2TypeAddr = 8
life2TypeMente = 9
life2ReturnFromChange = ""
life2MenteShukujitsu = ""
life2DataGetTypeDate = 0
life2DataGetTypeOr = 1
life2DataGetTypeAnd = 2
life2DataGetTypeOneDay = 3

function life2OnLoad() {
  life2Init()
  life2Top()
}

function life2OnUnload() {
}

function life2Init() {
  life2Id = document.getElementById("life2")
  life2Dt = new DataAndTransaction("demo-2t-", [life2TypeAddr, addr2Sep, addr2Del]) 
  life2Cal = new Calendar2()
  life2UiNum = new UiNum(life2Id)
  life2UiHiduke = new UiHiduke(life2Id)
  mente2Init("demo-mente2-")
}

function life2Top() {
  var s = "<pre>"
  s += "<button onClick=\"life2View()\"></button>"
  s += "<button onClick=\"sch2CalTop()\">ͽ</button>"
  s += "<button onClick=\"memo2ViewTop()\">ḫ</button>"
  s += "<button onClick=\"search2KeywordTop()\"></button>"
  s += "<button onClick=\"search2HidukeTop()\"></button>\n"
  s += "<button onClick=\"book2New()\"></button>"
  s += "<button onClick=\"book2Re()\">Ʒ</button>"
  s += "<button onClick=\"addr2ViewTop()\">Ϣ</button>\n"
  s += "<button onClick=\"sch2New()\">ͽ</button>"
  s += "<button onClick=\"memo2New()\"></button>"
  s += "<button onClick=\"addr2TopNew()\">Ϣ</button>\n"
  s += "<button onClick=\"mente2Top()\">ݼ</button>"
  s += "<button onClick=\"life2Setsumei()\"></button>\n"
  s += "</pre>"
  life2Id.innerHTML = s
}

function life2Alert() {
  alert("")
}

function life2View() {
  var type = 0
  if(life2View.arguments.length > 0) type = life2View.arguments[0]
  var s = "<pre>"
  s += "<a name=\"0\"><button class=\"c1\" onClick=\"life2Top()\"></button></a> "
  s += "<button class=\"c1\" onClick=\"life2View(1)\"></button> "
  s += "<button class=\"c1\" onClick=\"life2View(2)\"></button> "
  s += "<button class=\"c1\" onClick=\"life2View(3)\"></button> "
  s += "<a href=\"#e\"></a>\n"
  life2Cal.now()
  switch(type){
  case 1:
    life2Cal.addDate(-1)
    break
  case 2:
    life2Cal.addDate(-7)
    break
  case 3: {
    var a = life2Cal.get()
    life2Cal.set(a[0], a[1], 1, a[3], a[4], 0)
  } break
  }
  s += life2ViewStr(life2Dt.get(life2Cal.dataStr()), "life2View")
  s += "<a name=\"e\"><button class=\"c1\" onClick=\"life2Top()\"></button></a> <a href=\"#0\"></a>"
  s += "</pre>"
  life2Id.innerHTML = s
}

function life2ViewStr(a, r) {
  book2ViewInit()
  life2ReturnFromChange = r
  var s = "", cnt = 1, i, ds = ""
  for(i = 0; i < a.length; i++){
    var d = a[i][0].substr(0, 8)
    var t = parseInt(a[i][0].substr(8, 1)) 
    if(ds < d && t < life2TypeAddr){
      s += "<a name=\"" + cnt + "\">" + life2Cal.dateStr2(d) + "</a>"
      s += " <a href=\"#" + (cnt +1) + "\"></a>"
      s += "  <a href=\"#0\"></a>\n"
      cnt++
      ds = d
    }
    if(t >= life2TypeAddr) continue
    s += "<button class=\"list"
    if(t == life2TypeSch) s += "a"
    s += "\" onClick=life2Change(\"" + a[i][2] + "\")>" + a[i][0].substr(9, 4) + "</button> "
    switch(t){
    case life2TypeSch:
      s += sch2View(a[i][1]) + "\n"
      break
    case life2TypeMemo:
      s += memo2View(a[i][1]) + "\n"
      break
    case life2TypeBook:
      s += book2View(a[i][1]) + "\n"
      break
    }
  }
  return s
}

function life2Change(trKey) {
  var a = life2Dt.dataGetFromTrKey(trKey)
  if(a == null){
    alert("life2Chagne: transaction key " + trKey + " ޤǤ")
    return
  } 
  switch(parseInt(a[0].substr(8, 1))){
  case life2TypeSch:
    sch2Change(a)
    break
  case life2TypeMemo:
    memo2Change(a)
    break
  case life2TypeBook:
    book2Change(a)
    break
  default:
    alert("debug: " + a)
  }
}

function life2Setsumei() {
  var s = "<pre style=\"font-size: 12pt;\">"
  s += "<button onClick=\"life2Top()\"></button>\n"
  s += "<b>ѤƤϤʤʸ(̣դ˻ѤƤ뤿)</b>\n"
  s += "()###() Transactionǡڤ(ƤǻԲ)\n"
  s += "()---() Ϣǡڤ(ϢǤΤ߻Բ)\n"
  s += "\n<b>ȷǡե</b>\n"
  s += "ɤ()̾ʤ\n"
  s += "ɤߤΤߤǤOK(ʿ̾Τߤ̾ξ)\n"
  s += "ʣԤξ2ܤΤɽ\n"
  s += "\n<b>Ϣǡե</b>\n"
  s += "ɤ()̾()(ԤOK)\n"
  s += "ɤߥեɤƬǡֺ פȤʸϻԲ\n"
  s += "</pre>"
  life2Id.innerHTML = s
}
